//! Web server state
use super::*;
use tokio::{
    sync::{
	RwLock,
    },
};

#[derive(Debug)]
pub struct State
{
    backend: RwLock<ServerState>,
    settings: Settings,
}

impl State
{
    /// Create state from a backend state and server settings
    pub fn new(backend: ServerState, settings: Settings) -> Self
    {
	Self {
	    backend: RwLock::new(backend),
	    settings,
	}
    }

    /// The web server settings
    pub fn cfg(&self) -> &Settings
    {
	&self.settings
    }
}
